Option Explicit On
Option Strict On

Imports Microsoft.VisualBasic
Imports System.Diagnostics
Imports System.Security.Cryptography
Imports System.Text
Imports System.IO

Public Class DataEncryption
	'http://www.project602.com/post/dot+net+encryption+class
	'
	'This is a simple TripleDES(192bit) data encryption class that allows you to specify your own secret key
	'I conglomed this together from stuff at 15seconds and guys4rolla then made a buch of modifications/upgrades
	'just for reference, here are the originals
	'http://www.15seconds.com/Issue/021210.htm
	'http://www.4guysfromrolla.com/webtech/090501-1.shtml
	'
	'Feel free to use this class and/or code however you like (commercial, recreational, hysterical)
	'
	'Jason R. - project602.com



	Private my_error_message As String
	Private my_key_byte_array(23) As Byte
	Private my_vector_byte_array(23) As Byte


	Public ReadOnly Property ErrorMessage() As String
		Get
			Return my_error_message
		End Get
	End Property



	'INSTANTIATION
	Sub New()
		Dim passphrase As String
		Dim passphrase_byte_array As Byte()
		Dim n As Int32

		'THIS IS YOUR SECRET PASSPHRASE
		'CHANGE THIS TO WHATEVER YOU LIKE JUST MAKE SURE ITS 48 CHARACTERS OR LONGER
		'AND CONTAINS ONLY LETTERS, SPACES AND NUMBERS
		passphrase = "Put your secret passphrase here I will use it to generate the key and vector"

		passphrase_byte_array = System.Text.Encoding.ASCII.GetBytes(passphrase)
		my_error_message = ""

		For n = 0 To 23
			my_key_byte_array(n) = passphrase_byte_array(n)
			HttpContext.Current.Trace.Write("Byte Value", passphrase_byte_array(n).ToString())
		Next

		For n = 24 To 47
			my_vector_byte_array(n - 24) = passphrase_byte_array(n)
		Next
	End Sub



	'PRIVATE/PROTECTED FUNCTIONS



	'PUBLIC FUNCTIONS
	'This function encrypts the given string or using the keys set at initialization using TripleDES
	'It should always return the encrypted string
	Public Function encryptString(ByVal value As String) As String
		Dim crypto_provider As TripleDESCryptoServiceProvider
		Dim memory_stream As MemoryStream
		Dim crypto_transform As ICryptoTransform
		Dim crypto_stream As CryptoStream
		Dim stream_writer As StreamWriter
		Dim result_buffer As Byte()
		Dim encrypted_string As String

		crypto_provider = New TripleDESCryptoServiceProvider()
		memory_stream = New MemoryStream
		crypto_transform = crypto_provider.CreateEncryptor(my_key_byte_array, my_vector_byte_array)
		crypto_stream = New CryptoStream(memory_stream, crypto_transform, CryptoStreamMode.Write)
		stream_writer = New StreamWriter(crypto_stream)

		stream_writer.Write(value)
		stream_writer.Flush()
		crypto_stream.FlushFinalBlock()
		memory_stream.Flush()

		result_buffer = memory_stream.GetBuffer()
		encrypted_string = Convert.ToBase64String(result_buffer, 0, Convert.ToInt32(memory_stream.Length))

		Return encrypted_string
	End Function



	'This function decrypts a string that has been encrypted with the function above
	'using the keys set at initialization - it should always return the encrypted string
	Public Function decryptString(ByVal value As String) As String
		Dim byte_array As Byte()
		Dim crypto_provider As TripleDESCryptoServiceProvider
		Dim memory_stream As MemoryStream
		Dim crypto_transform As ICryptoTransform
		Dim crypto_stream As CryptoStream
		Dim stream_reader As StreamReader
		Dim decrypted_string As String

		byte_array = Convert.FromBase64String(value)
		crypto_provider = New TripleDESCryptoServiceProvider()
		memory_stream = New MemoryStream(byte_array)
		crypto_transform = crypto_provider.CreateDecryptor(my_key_byte_array, my_vector_byte_array)
		crypto_stream = New CryptoStream(memory_stream, crypto_transform, CryptoStreamMode.Read)
		stream_reader = New StreamReader(crypto_stream)

		decrypted_string = stream_reader.ReadToEnd()

		Return decrypted_string
	End Function

End Class
